"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const client_1 = require("../src/client");
const anchor = __importStar(require("@coral-xyz/anchor"));
const promises_1 = __importDefault(require("readline/promises"));
async function main() {
    const rl = promises_1.default.createInterface({
        input: process.stdin,
        output: process.stdout,
    });
    const distributionNumber = parseInt(await rl.question('Distribution Number: '));
    const provider = anchor.AnchorProvider.env();
    const client = new client_1.MangoMintsRedemptionClient(provider);
    const distribution = await client.loadDistribution(distributionNumber);
    const claims = await distribution.getClaims(provider.wallet.publicKey);
    const claimed = await distribution.getClaimed(provider.wallet.publicKey);
    console.log('Claims:', claims);
    console.log('Claimed:', claimed);
    for (const claim of claims) {
        if (!claimed || !claimed.includes(claim.mint)) {
            console.log(`Claiming ${claim.quantity} ${claim.mintProperties['name']}...`);
            console.log(await distribution.claim(claim.mint));
        }
    }
}
main();
