"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const promises_1 = __importDefault(require("readline/promises"));
const anchor = __importStar(require("@coral-xyz/anchor"));
const client_1 = require("../src/client");
const METADATA = __importStar(require("./example-metadata.json"));
const metadata_1 = require("../src/accounts/metadata");
async function main() {
    const provider = anchor.AnchorProvider.env();
    const client = new client_1.MangoMintsRedemptionClient(provider);
    const metadata = new metadata_1.Metadata(METADATA);
    console.log(JSON.stringify(METADATA));
    console.log('Upload metadata...');
    const rl = promises_1.default.createInterface({
        input: process.stdin,
        output: process.stdout,
    });
    const distributionNumber = parseInt(await rl.question('Distribution Number: '));
    const now = Date.now() / 1000;
    const distributionStartQ = await rl.question('Distribution Start Timestamp (s) (default now+1h): ');
    const distributionStart = distributionStartQ.length
        ? new Date(parseInt(distributionStartQ) * 1000)
        : new Date(now + 3600 * 1000);
    const distributionDuration = parseInt(await rl.question('Distribution Duration (s): '));
    const metadataUrl = await rl.question('Metadata URL: ');
    await client.createDistribution(distributionNumber, provider.wallet.publicKey, distributionStart, distributionDuration, metadata, metadataUrl);
    const distribution = await client.loadDistribution(distributionNumber);
    console.log(`Distribution ${distributionNumber} created: ${distribution.publicKey.toString()}`);
    const tokenTotals = distribution.metadata.claims.reduce((totals, c) => {
        if (totals[c.mintIndex]) {
            totals[c.mintIndex] += c.quantity;
        }
        else {
            totals[c.mintIndex] = c.quantity;
        }
        return totals;
    }, []);
    for (let i = 0; i < tokenTotals.length; i++) {
        const total = tokenTotals[i];
        if (total) {
            const mint = distribution.metadata.mints[i];
            const confirm = await rl.question(`Transfer ${total} ${mint.properties['name']} to vault? (y/n)`);
            if (confirm == 'y') {
                await distribution.transferToVault(new anchor.web3.PublicKey(mint.address), BigInt(total));
            }
        }
    }
}
main();
