"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Metadata = void 0;
const merkletreejs_1 = require("merkletreejs");
const keccak256_1 = __importDefault(require("keccak256"));
const anchor_1 = require("@coral-xyz/anchor");
class Metadata {
    name;
    mints;
    claims;
    constructor(obj) {
        this.name = obj.name;
        this.mints = obj.mints;
        this.claims = obj.claims;
    }
    toMerkleTree() {
        const keys = this.claims.map((c) => {
            const quantity = Buffer.alloc(8);
            quantity.writeBigUInt64LE(BigInt(c.quantity));
            const mint = this.mints[c.mintIndex];
            return Buffer.concat([
                new anchor_1.web3.PublicKey(c.claimant).toBuffer(),
                new anchor_1.web3.PublicKey(mint.address).toBuffer(),
                quantity,
            ]);
        });
        return new merkletreejs_1.MerkleTree(keys, keccak256_1.default, {
            sortPairs: true,
            hashLeaves: true,
        });
    }
}
exports.Metadata = Metadata;
