import { AnchorProvider, Program, web3 } from '@coral-xyz/anchor';
import { MangoMintsRedemption } from './mango_mints_redemption';
import { Distribution } from './accounts/distribution';
import { Metadata } from './accounts/metadata';
type PublicKey = web3.PublicKey;
export declare const MANGO_MINTS_REDEMPTION_ID: web3.PublicKey;
export declare class MangoMintsRedemptionClient {
    provider: AnchorProvider;
    programId: web3.PublicKey;
    program: Program<MangoMintsRedemption>;
    constructor(provider: AnchorProvider, programId?: web3.PublicKey);
    loadDistribution(number: number): Promise<Distribution>;
    loadDistributionFromPublicKey(publicKey: PublicKey): Promise<Distribution>;
    createDistribution(number: number, authority: PublicKey, start: Date, duration: number, metadata: Metadata, metadataUrl: string): Promise<void>;
    editDistribution(): Promise<void>;
}
export {};
