"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MangoMintsRedemptionClient = exports.MANGO_MINTS_REDEMPTION_ID = void 0;
const anchor_1 = require("@coral-xyz/anchor");
const Token = __importStar(require("@solana/spl-token"));
const mango_mints_redemption_1 = require("./mango_mints_redemption");
const distribution_1 = require("./accounts/distribution");
// TODO
// Edit distribution
// Close claims accounts for expired distributions
exports.MANGO_MINTS_REDEMPTION_ID = new anchor_1.web3.PublicKey('3BUZXy9mPcsSCoxJQiBu2xxpMP6HEvFMZbaL5CAWwLUf');
class MangoMintsRedemptionClient {
    provider;
    programId;
    program;
    constructor(provider, programId = exports.MANGO_MINTS_REDEMPTION_ID) {
        this.provider = provider;
        this.programId = programId;
        this.program = new anchor_1.Program(mango_mints_redemption_1.IDL, programId, provider);
    }
    async loadDistribution(number) {
        const distributionNum = Buffer.alloc(4);
        distributionNum.writeUint32LE(number);
        const [publicKey] = await anchor_1.web3.PublicKey.findProgramAddress([Buffer.from('Distribution'), distributionNum], this.programId);
        const distribution = await this.loadDistributionFromPublicKey(publicKey);
        await distribution.loadMetadata();
        return distribution;
    }
    async loadDistributionFromPublicKey(publicKey) {
        const distribution = await this.program.account.distribution.fetch(publicKey);
        return new distribution_1.Distribution(this.programId, this.program, publicKey, distribution.distributionNum, distribution.merkleRoot, distribution.authority, distribution.start, distribution.duration, distribution.metadata);
    }
    async createDistribution(number, authority = this.provider.wallet.publicKey, start, duration, metadata, metadataUrl) {
        const distribution = distribution_1.Distribution.findAddress(number, this.programId);
        const merkleTree = metadata.toMerkleTree();
        const metadataUrlBuf = Buffer.alloc(256);
        metadataUrlBuf.write(metadataUrl);
        await this.program.methods
            .distributionCreate(number, [...merkleTree.getRoot()], new anchor_1.BN(start.getTime() / 1000), new anchor_1.BN(duration), [...metadataUrlBuf])
            .accounts({
            distribution,
            payer: this.provider.wallet.publicKey,
            authority,
            systemProgram: anchor_1.web3.SystemProgram.programId,
        })
            .rpc();
        for (const mint of metadata.mints) {
            console.log(mint);
            const mintPubkey = new anchor_1.web3.PublicKey(mint.address);
            const vault = anchor_1.web3.PublicKey.findProgramAddressSync([
                Buffer.from('Vault'),
                distribution.toBuffer(),
                mintPubkey.toBuffer(),
            ], this.programId)[0];
            await this.program.methods
                .vaultCreate()
                .accounts({
                distribution,
                vault,
                mint: mintPubkey,
                payer: this.provider.wallet.publicKey,
                tokenProgram: Token.TOKEN_PROGRAM_ID,
                associatedTokenProgram: Token.ASSOCIATED_TOKEN_PROGRAM_ID,
                systemProgram: anchor_1.web3.SystemProgram.programId,
                rent: anchor_1.web3.SYSVAR_RENT_PUBKEY,
            })
                .rpc();
        }
    }
    async editDistribution() { }
}
exports.MangoMintsRedemptionClient = MangoMintsRedemptionClient;
