"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IDL = void 0;
exports.IDL = {
    "version": "0.1.0",
    "name": "mango_mints_redemption",
    "instructions": [
        {
            "name": "distributionCreate",
            "accounts": [
                {
                    "name": "distribution",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "payer",
                    "isMut": true,
                    "isSigner": true
                },
                {
                    "name": "authority",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "systemProgram",
                    "isMut": false,
                    "isSigner": false
                }
            ],
            "args": [
                {
                    "name": "distributionNum",
                    "type": "u32"
                },
                {
                    "name": "merkleRoot",
                    "type": {
                        "array": [
                            "u8",
                            32
                        ]
                    }
                },
                {
                    "name": "start",
                    "type": "u64"
                },
                {
                    "name": "duration",
                    "type": "u64"
                },
                {
                    "name": "metadata",
                    "type": {
                        "array": [
                            "u8",
                            256
                        ]
                    }
                }
            ]
        },
        {
            "name": "distributionClose",
            "accounts": [
                {
                    "name": "distribution",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "authority",
                    "isMut": true,
                    "isSigner": true
                },
                {
                    "name": "solDestination",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "systemProgram",
                    "isMut": false,
                    "isSigner": false
                }
            ],
            "args": []
        },
        {
            "name": "distributionEdit",
            "accounts": [
                {
                    "name": "distribution",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "authority",
                    "isMut": false,
                    "isSigner": true
                }
            ],
            "args": [
                {
                    "name": "merkleRootOpt",
                    "type": {
                        "option": {
                            "array": [
                                "u8",
                                32
                            ]
                        }
                    }
                },
                {
                    "name": "authorityOpt",
                    "type": {
                        "option": "publicKey"
                    }
                },
                {
                    "name": "startOpt",
                    "type": {
                        "option": "u64"
                    }
                },
                {
                    "name": "durationOpt",
                    "type": {
                        "option": "u64"
                    }
                },
                {
                    "name": "metadataOpt",
                    "type": {
                        "option": {
                            "array": [
                                "u8",
                                256
                            ]
                        }
                    }
                }
            ]
        },
        {
            "name": "vaultCreate",
            "accounts": [
                {
                    "name": "distribution",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "vault",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "mint",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "payer",
                    "isMut": true,
                    "isSigner": true
                },
                {
                    "name": "tokenProgram",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "associatedTokenProgram",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "systemProgram",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "rent",
                    "isMut": false,
                    "isSigner": false
                }
            ],
            "args": []
        },
        {
            "name": "vaultClose",
            "accounts": [
                {
                    "name": "distribution",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "vault",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "mint",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "authority",
                    "isMut": true,
                    "isSigner": true
                },
                {
                    "name": "destination",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "systemProgram",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "tokenProgram",
                    "isMut": false,
                    "isSigner": false
                }
            ],
            "args": []
        },
        {
            "name": "claimAccountCreate",
            "accounts": [
                {
                    "name": "distribution",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "claimAccount",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "claimant",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "payer",
                    "isMut": true,
                    "isSigner": true
                },
                {
                    "name": "systemProgram",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "rent",
                    "isMut": false,
                    "isSigner": false
                }
            ],
            "args": []
        },
        {
            "name": "claimAccountClose",
            "accounts": [
                {
                    "name": "distribution",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "claimAccount",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "payer",
                    "isMut": true,
                    "isSigner": true
                },
                {
                    "name": "systemProgram",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "tokenProgram",
                    "isMut": false,
                    "isSigner": false
                }
            ],
            "args": []
        },
        {
            "name": "claim",
            "accounts": [
                {
                    "name": "distribution",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "vault",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "tokenAccount",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "claimAccount",
                    "isMut": true,
                    "isSigner": false
                },
                {
                    "name": "mint",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "claimant",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "tokenProgram",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "systemProgram",
                    "isMut": false,
                    "isSigner": false
                },
                {
                    "name": "rent",
                    "isMut": false,
                    "isSigner": false
                }
            ],
            "args": [
                {
                    "name": "quantity",
                    "type": "u64"
                },
                {
                    "name": "proof",
                    "type": {
                        "vec": {
                            "array": [
                                "u8",
                                32
                            ]
                        }
                    }
                }
            ]
        }
    ],
    "accounts": [
        {
            "name": "claimAccount",
            "type": {
                "kind": "struct",
                "fields": [
                    {
                        "name": "claims",
                        "type": {
                            "array": [
                                "publicKey",
                                16
                            ]
                        }
                    }
                ]
            }
        },
        {
            "name": "distribution",
            "type": {
                "kind": "struct",
                "fields": [
                    {
                        "name": "distributionNum",
                        "type": "u32"
                    },
                    {
                        "name": "merkleRoot",
                        "type": {
                            "array": [
                                "u8",
                                32
                            ]
                        }
                    },
                    {
                        "name": "authority",
                        "type": "publicKey"
                    },
                    {
                        "name": "padding1",
                        "type": {
                            "array": [
                                "u8",
                                4
                            ]
                        }
                    },
                    {
                        "name": "start",
                        "type": "u64"
                    },
                    {
                        "name": "duration",
                        "type": "u64"
                    },
                    {
                        "name": "metadata",
                        "type": {
                            "array": [
                                "u8",
                                256
                            ]
                        }
                    },
                    {
                        "name": "bump",
                        "type": "u8"
                    },
                    {
                        "name": "padding2",
                        "type": {
                            "array": [
                                "u8",
                                7
                            ]
                        }
                    }
                ]
            }
        }
    ],
    "errors": [
        {
            "code": 6000,
            "name": "SomeError"
        },
        {
            "code": 6001,
            "name": "DistributionActive"
        },
        {
            "code": 6002,
            "name": "DistributionNotActive"
        },
        {
            "code": 6003,
            "name": "DistributionStarted"
        },
        {
            "code": 6004,
            "name": "AlreadyClaimed"
        },
        {
            "code": 6005,
            "name": "BadSigner"
        },
        {
            "code": 6006,
            "name": "NoClaimSlots"
        },
        {
            "code": 6007,
            "name": "InvalidProof"
        },
        {
            "code": 6008,
            "name": "InvalidOwner"
        }
    ]
};
