import { MerkleTree } from 'merkletreejs';
import keccak256 from 'keccak256';
import { web3 } from '@coral-xyz/anchor';
export class Metadata {
    name;
    mints;
    claims;
    constructor(obj) {
        this.name = obj.name;
        this.mints = obj.mints;
        this.claims = obj.claims;
    }
    toMerkleTree() {
        const keys = this.claims.map((c) => {
            const quantity = Buffer.alloc(8);
            quantity.writeBigUInt64LE(BigInt(c.quantity));
            const mint = this.mints[c.mintIndex];
            return Buffer.concat([
                new web3.PublicKey(c.claimant).toBuffer(),
                new web3.PublicKey(mint.address).toBuffer(),
                quantity,
            ]);
        });
        return new MerkleTree(keys, keccak256, {
            sortPairs: true,
            hashLeaves: true,
        });
    }
}
